DECLARE FUNCTION runlength$ (s$)
DECLARE FUNCTION unmushstring$ (s$)
DECLARE FUNCTION mushstring$ (s$)
DECLARE SUB packfile (offset&, src$, dest$)
DECLARE FUNCTION squishstring$ (s$)
DECLARE FUNCTION croplong% (lng&)
DECLARE FUNCTION small% (n1%, n2%)
DECLARE FUNCTION large% (n1%, n2%)
'$DYNAMIC
DEFINT A-Z

'packfile 0, "wh_demo.txt", "wh_demo.sq"
'packfile 0, "whatsnew.txt", "whatsnew.sq"
packfile 0, "wander.til", "wand_til.sq"

REM $STATIC
FUNCTION croplong (lng&)
  SELECT CASE lng&
    CASE IS > 32767
      croplong = 32767
    CASE IS < -32768
      croplong = -32768
    CASE ELSE
      croplong = lng&
  END SELECT
END FUNCTION

FUNCTION large (n1, n2)
large = n1
IF n2 > n1 THEN large = n2
END FUNCTION

FUNCTION mushstring$ (s$)

  msh$ = CHR$(0)

  i = 0
  DO WHILE i < LEN(s$)
    FOR j = 16 TO 5 STEP -1
      seek$ = MID$(s$, i + 1, j)
      IF LEN(seek$) = j THEN
        findat = INSTR(1, msh$, seek$)
        IF findat THEN
          'PRINT "found "; seek$; " at "; findat
          msh$ = msh$ + CHR$(0) + CHR$(j) + CHR$(findat AND 255) + CHR$(findat \ 256)
          i = i + (j - 1)
          EXIT FOR
        END IF
      END IF
      findat = 0
    NEXT j
    IF findat = 0 THEN
      'PRINT "adding " + MID$(s$, i + 1, 1)
      msh$ = msh$ + MID$(s$, i + 1, 1)
    END IF
    i = i + 1
  LOOP

  mushstring$ = msh$

END FUNCTION

SUB packfile (offset&, src$, dest$)

infile = FREEFILE
OPEN src$ FOR BINARY AS infile
outfile = FREEFILE
OPEN dest$ FOR BINARY AS outfile

filesize& = LOF(infile)
PRINT "total size"; filesize&

blocksize = 4096

o& = offset&

i& = 0
DO WHILE i& < filesize&
  PRINT ".";
  thisblock = small(blocksize, croplong(filesize& - i&))
  a$ = STRING$(thisblock, CHR$(0))
  GET #infile, i& + 1, a$
  a$ = mushstring$(squishstring$(a$))
  'a$ = mushstring$(runlength$(a$))
  'a$ = squishstring(a$)
  'a$ = mushstring(a$)
  'a$ = runlength(a$)
  PUT #outfile, o& + 1, a$
  o& = o& + LEN(a$)
  i& = i& + blocksize
LOOP

PRINT
PRINT o&; "bytes compressed, (with header,"; o& + 14; ")"

PUT #outfile, o& + 1, o&
PUT #outfile, o& + 1 + 4, filesize&
PUT #outfile, o& + 1 + 8, offset&
PUT #outfile, o& + 1 + 12, blocksize

CLOSE infile
CLOSE outfile

END SUB

FUNCTION runlength$ (s$)
  DIM freq(255)
  rl$ = ""

  i = 0
  DO WHILE i < LEN(s$)
    char = ASC(MID$(s$, i + 1, 1))
    freq(char) = freq(char) + 1
    IF i > 0 THEN
      IF char <> ASC(MID$(s$, i, 1)) THEN
        freq(char) = freq(char) - 2
      END IF
    END IF
    i = i + 1
  LOOP

  lowest = 0
  FOR i = 1 TO 255
    IF freq(i) < freq(lowest) THEN lowest = i
  NEXT i
  freq(lowest) = 0

  FOR i = 0 TO 255
    IF freq(i) > 1 THEN rl$ = rl$ + CHR$(i)
  NEXT i

  rl$ = CHR$(LEN(rl$)) + rl$

  mode = -1
  count = 0
  i = 0
  DO WHILE i < LEN(s$)
    char = ASC(MID$(s$, i + 1, 1))
    SELECT CASE mode
    CASE -1
      IF freq(char) > 1 THEN
        count = 0
        mode = char
      END IF
      rl$ = rl$ + CHR$(char)
      i = i + 1
    CASE ELSE
      IF char = mode THEN
        count = count + 1
        IF count >= 255 THEN
          rl$ = rl$ + CHR$(count): count = 0
          mode = -1
        END IF
        i = i + 1
      ELSE
        rl$ = rl$ + CHR$(count): count = 0
        mode = -1
      END IF
    END SELECT
  LOOP
  IF count THEN rl$ = rl$ + CHR$(count): count = 0

  runlength$ = rl$

END FUNCTION

FUNCTION small (n1, n2)
small = n1
IF n2 < n1 THEN small = n2
END FUNCTION

FUNCTION squishstring$ (s$)
  sq$ = ""

  nocomp$ = ""

  i = 0
  DO WHILE i < LEN(s$)
    a$ = LEFT$(MID$(s$, i + 1), 4)
    IF LEN(a$) > 3 THEN
      seek$ = LEFT$(a$, 1)
      IF seek$ = MID$(a$, 2, 1) AND seek$ = MID$(a$, 3, 1) AND seek$ = MID$(a$, 4, 1) THEN
        dup = 1
        FOR j = i + 1 TO LEN(s$) - 1
          IF MID$(s$, j + 1, 1) = seek$ THEN
            dup = dup + 1
          ELSE
            EXIT FOR
          END IF
          IF dup >= 255 THEN EXIT FOR
        NEXT j
        IF LEN(nocomp$) THEN
          GOSUB writenocomp
        END IF
        sq$ = sq$ + CHR$(dup) + seek$
        i = i + dup - 1
      ELSE
        nocomp$ = nocomp$ + seek$
      END IF
    ELSE
      nocomp$ = nocomp$ + LEFT$(a$, 1)
    END IF
    IF LEN(nocomp$) >= 255 THEN GOSUB writenocomp
    i = i + 1
  LOOP
 
  IF LEN(nocomp$) THEN GOSUB writenocomp

  squishstring$ = sq$

EXIT FUNCTION

writenocomp:
  sq$ = sq$ + CHR$(0) + CHR$(LEN(nocomp$)) + nocomp$
  nocomp$ = ""
RETURN

END FUNCTION

FUNCTION unmushstring$ (s$)

 un$ = ""
 mode = 0

 i = 1
 DO WHILE i < LEN(s$)
   a$ = MID$(s$, i + 1, 1)
   IF a$ = CHR$(0) THEN
     position = ASC(MID$(s$, i + 3, 1)) + (ASC(MID$(s$, i + 4, 1)) * 256)
     un$ = un$ + MID$(s$, position, ASC(MID$(s$, i + 2, 1)))
     i = i + 3
   ELSE
     un$ = un$ + a$
   END IF
   i = i + 1
 LOOP

 unmushstring$ = un$

END FUNCTION

